<script setup lang="ts">
// import { ZoomMtg } from '@zoomus/websdk' } from '@zoomus/websdk'
import { storeToRefs } from 'pinia'
import { onBeforeRouteLeave } from 'vue-router'
import ZoomModal from '~~/components/O/ZoomModal.vue'
import { useCallStore } from '~~/store/call'
import { usePollStore } from '~~/store/poll'
import { useUIStore } from '~~/store/UI'
import { useZoomStore } from '~~/store/zoom'
import { useZoomClientStore } from '~~/store/zoomClient'

const ui = useUIStore()
const { mTabFull, isMobile, designNumber, waitingRoom, isDesign7, overlay } = storeToRefs(ui)
const zoom = useZoomStore()
const zoomClient = useZoomClientStore()
const poll = usePollStore()
const { modalPoll } = storeToRefs(poll)

onBeforeRouteLeave(() => {
  zoom.$patch({ model: true })
  try {
    zoomClient.leaveClient()
  }
  catch (e) {
    console.error(e)
  }
})
const infoButton = [
  {
    name: 'エントリー/求人情報を見る',
    link: 'https://www.uat.cognavi.jp/catalog/000465/000022/?new_grad=1&kyujinId=25191&tab=004',
    class: 'border-white bg-orange-500 text-white',
  }]
const iconButton = [
  {
    name: 'エントリー',
    class: 'i-clarity:note-edit-line',
  },
]

const call = useCallStore()
const { currentCall } = storeToRefs(call)
const timestamp = useTimestamp({ offset: 0 })
const shouldStart = computed(() => new Date(timestamp.value) > new Date(currentCall.value?.call?.expiration || ''))
watch(shouldStart, (newStart, oldStart) => {
  if (newStart && !oldStart && waitingRoom.value) {
    waitingRoom.value = false

    zoomClient.join(currentCall.value?.call.number, currentCall.value?.call.password)
  }
})
const style = computed(
  () =>
    designNumber.value === 7
      ? `
        #foot-bar{
          width: 200vw;
          margin-left: calc(50vw - 180px);
        }
        `
      : '',
)
useStyleTag(style)
const pushNoti = ref(null)
const push = (arg: any) => {
  console.log('pushing: ', arg)
  console.log('pushing: ', pushNoti.value?.push)
  pushNoti.value?.pushEvent && pushNoti.value?.pushEvent(arg)
}
</script>

<template>
  <MModalQuestion v-for="question in modalPoll" :id="question.id" :key="question.id" :question="question" @push="push" />
  <div v-for="icon in iconButton" v-if="isDesign7 && overlay" :key="icon.name" class="p-1 flex flex-col justify-center items-center flex-row  fixed right-margin bottom-0 hover:op-100 opacity-70">
    <div class="w-6 h-6" :class="icon.class" />
    <div>
      {{ icon.name }}
    </div>
  </div>
  <TCallPanel>
    <template #default>
      <MTab h-full w-full :start-tab="1">
        <ATabContent title="info" :lt-sm="mTabFull ? '' : 'hidden'">
          <MAttendees />
        </ATabContent>
        <ATabContent title="comment" :lt-sm="mTabFull ? '' : 'hidden'">
          <OChat />
        </ATabContent>
        <ATabContent title="question" :lt-sm="mTabFull ? '' : 'hidden'">
          <OQuestion />
        </ATabContent>
        <ATabContent title="poll" :lt-sm="mTabFull ? '' : 'hidden'">
          <OPoll />
        </ATabContent>
        <APushtoNoti ref="pushNoti" />
      </MTab>
    </template>
    <template #bottom>
      <div v-if="(isMobile)" h-15 flex flex-row>
        <div v-for="icon in iconButton" :key="icon.name" class="p-1 flex flex-col justify-center items-center flex-row hover:op-100 opacity-70">
          <div class="w-6 h-6" :class="icon.class" />
          <div>
            {{ icon.name }}
          </div>
        </div>
      </div>
      <div
        v-else
        class="w-full flex justify-end items-center bg-neutral-900 dark:bg-neutral-900 px-15 gap-2"
        lt-sm="justify-start"
      >
        <a
          v-for="info in infoButton"
          :key="info.name"
          :href="info.link"
          target="_blank"
          class="p-3 lg:min-w-[240px] min-w-fit rounded-md border whitespace-nowrap text-center"
          :class="info.class"
        >
          <button class="font-bold text-base">{{ info.name }}</button>
        </a>
      </div>
    </template>
    <template #left>
      <AMeetingClientPortal />
      <ACompanyInfo class="slot3" />
    </template>
  </TCallPanel>
</template>

<style>
.right-margin{
  right: calc(50vw - 180px);
}
[feature-type="sharing"]{
  display: none !important;
}
.participants-section-container__participants-footer-bottom{
  display: none;
}
.common-ui-component__dropdown-divider {
  display: none;
}
li:has(>a[aria-label="全画面表示"]) {
  display: none;
}
ul[aria-labelledby="securityOptionMenu"] {
  display: none !important;
}
div:has(>button[data-a-l="5-2-0"]) {
  display: none;
}
button[data-a-l="5-0-0"] {
  display: none;
}
button[data-a-l="5-0-2"] {
  display: none;
}
button[data-a-l="5-0-3"] {
  display: none;
}
button[data-a-l="5-0-4"] {
  display: none;
}
button[data-a-l="5-0-5"] {
  display: none;
}
button[data-a-l="5-0-6"] {
  display: none;
}
.reaction-simple-picker__row {
  margin-right: 4px;
}
[feature-type="record"] {
  display: none !important;
}
[feature-type="pasue-stop-record"]{
  display: none !important;
}
[feature-type="security"] {
  display: none !important;
}
div[aria-label="suspension-window"] {
  display: none !important;
}
</style>

